﻿using System;
using System.Net;
using System.Net.Http;
using Polly;
using Polly.Retry;

namespace PollyWebApi2DI.App_Start
{
    public class Policies
    {
        public readonly RetryPolicy<HttpResponseMessage> InternalServerErrorPolicy;
        public readonly RetryPolicy<HttpResponseMessage> RequestTimeoutPolicy;
        public Policies()
        {
            InternalServerErrorPolicy = Policy.HandleResult<HttpResponseMessage>(
               r => r.StatusCode == HttpStatusCode.InternalServerError)
           .WaitAndRetryAsync(3,
               retryAttempt => TimeSpan.FromSeconds(retryAttempt));

            RequestTimeoutPolicy = Policy.HandleResult<HttpResponseMessage>(
                r => r.StatusCode == HttpStatusCode.RequestTimeout)
            .WaitAndRetryAsync(3, 
                retryAttempt => TimeSpan.FromSeconds(Math.Pow(0.2, retryAttempt)));
        }
    }
}