﻿using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Threading.Tasks;
using System.Web.Http;
using PollyWebApi2DI.App_Start;

namespace PollyWebApi2.Controllers
{
    [RoutePrefix("api/items")]
    public class ItemsController : ApiController
    {
        private readonly Policies _policies;
        public ItemsController(Policies policies)
        {
            _policies = policies;
        }

        public async Task<IHttpActionResult> Get()
        {
            var httpClient = GetHttpClient();
            string requestEndpoint = "itemsCalculator/Get";

            HttpResponseMessage httpResponse = await _policies.InternalServerErrorPolicy.ExecuteAsync(() => httpClient.GetAsync(requestEndpoint));

            IEnumerable<int> numbers = await httpResponse.Content.ReadAsAsync<IEnumerable<int>>();

            return Ok(numbers);
        }
      
        private HttpClient GetHttpClient()
        {
            var httpClient = new HttpClient();
            httpClient.BaseAddress = new Uri(@"http://localhost:2351/api/");
            httpClient.DefaultRequestHeaders.Accept.Clear();
            httpClient.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
            return httpClient;
        }
    }
}
