﻿using System;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Threading.Tasks;
using System.Web.Http;
using PollyWebApi2DI.App_Start;

namespace PollyWebApi2DI.Controllers
{
    [RoutePrefix("api/person")]
    public class PersonController : ApiController
    {
        private readonly Policies _policies;
        public PersonController(Policies policies)
        {
            _policies = policies;
        }

        public async Task<IHttpActionResult> Get()
        {
            var httpClient = GetHttpClient();
            string requestEndpoint = "PersonCalculator/Get";

            HttpResponseMessage httpResponse = await _policies.RequestTimeoutPolicy.ExecuteAsync(() => httpClient.GetAsync(requestEndpoint));

            if (httpResponse.IsSuccessStatusCode)
            {
                int number = await httpResponse.Content.ReadAsAsync<int>();
                return Ok(number);
            }

            string errorMessage = await httpResponse.Content.ReadAsStringAsync();
            return Content(httpResponse.StatusCode, errorMessage);
        }

        private HttpClient GetHttpClient()
        {
            var httpClient = new HttpClient();
            httpClient.BaseAddress = new Uri(@"http://localhost:2351/api/");
            httpClient.DefaultRequestHeaders.Accept.Clear();
            httpClient.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
            return httpClient;
        }
    }
}
